searchNodes=[{"doc":"","ref":"Qlc.html","title":"Qlc","type":"module"},{"doc":"","ref":"Qlc.html#bind/1","title":"Qlc.bind/1","type":"function"},{"doc":"variable binding list to erlang_binding list","ref":"Qlc.html#bind/2","title":"Qlc.bind/2","type":"function"},{"doc":"create qlc cursor from qlc_handle(create processes)","ref":"Qlc.html#cursor/1","title":"Qlc.cursor/1","type":"function"},{"doc":"delete qlc cursor(kill processes)","ref":"Qlc.html#delete_cursor/1","title":"Qlc.delete_cursor/1","type":"function"},{"doc":"eval qlc_handle","ref":"Qlc.html#e/1","title":"Qlc.e/1","type":"function"},{"doc":"erlang ast with binding variables to qlc_handle","ref":"Qlc.html#expr_to_handle/3","title":"Qlc.expr_to_handle/3","type":"function"},{"doc":"string to erlang ast","ref":"Qlc.html#exprs/1","title":"Qlc.exprs/1","type":"function"},{"doc":"fold qlc_handle with accumulatorexample iex&gt; require Qlc iex&gt; list = [a: 1,b: 2,c: 3] iex&gt; qlc_handle = Qlc.q(&quot;[X || X = {K,V} &lt;- L, K =/= Item]&quot;, ...&gt; [L: list, Item: :b]) ...&gt; Qlc.fold(qlc_handle, [], fn({k,v}, acc) -&gt; ...&gt; [{v, k}|acc] ...&gt; end) [{3, :c}, {1, :a}] iex&gt; :mnesia.create_table(:t1, [{:attributes, [:k, :v]}]) {:atomic, :ok} iex&gt; :mnesia.transaction(fn() -&gt; ...&gt; Qlc.fold(qlc_handle, [], fn({k, v}, acc) -&gt; ...&gt; :mnesia.write({:t1, k, v}) ...&gt; [{:t1, k, v}|acc] ...&gt; end) ...&gt; end) {:atomic, [{:t1, :c, 3}, {:t1, :a, 1}]} iex&gt; qh = Qlc.q(&quot;[X || X = {T, K, V} &lt;- L, K =/= Item]&quot;, ...&gt; [L: :mnesia.table(:t1), Item: :a]) iex&gt; :mnesia.transaction(fn() -&gt; ...&gt; Qlc.fold(qh, [], fn({t, k, v}, acc) -&gt; ...&gt; IO.inspect({t, k, v}) ...&gt; :ok = :mnesia.write({:t1, k, v+1}) ...&gt; [{:t1, k, v+1}|acc] ...&gt; end) ...&gt; end) {:atomic, [{:t1, :c, 4}]}","ref":"Qlc.html#fold/4","title":"Qlc.fold/4","type":"function"},{"doc":"sorts tuples on query_handle. The sort is performed on the element(s) mentioned in key_pos. If two tuples compare equal (==) on one element, the next element according to key_pos is compared. The sort is stable. key_pos is indexing by 0.exampleiex&gt; list = [a: 3, b: 2, c: 1] iex&gt; Qlc.q(&quot;[ X || X &lt;- L]&quot;, [L: list]) |&gt; ...&gt; Qlc.keysort(1, order: :ascending) |&gt; ...&gt; Qlc.e() [c: 1, b: 2, a: 3] iex&gt; list = [a: 1, b: 2, c: 3, d: 2] ...&gt; Qlc.q(&quot;[X || X &lt;- L]&quot;, [L: list]) |&gt; ...&gt; Qlc.keysort(1, order: :descending, unique: true) |&gt; ...&gt; Qlc.e() [c: 3, b: 2, a: 1]","ref":"Qlc.html#keysort/3","title":"Qlc.keysort/3","type":"function"},{"doc":"Returns some or all of the remaining answers to a Qlc.Cursor. Only the owner of Qlc.Cursor can retrieve answers.Optional argument number_of_answers determines the maximum number of answers returned. Defaults to 10. If less than the requested number of answers is returned, subsequent calls to next_answers return [].Examples: iex&gt; require Qlc iex&gt; list = [a: 1, b: 2,c: 3, d: 4, e: 5, f: 6] iex&gt; qlc_handle = Qlc.q(&quot;[X || X = {K,V} &lt;- L]&quot;, ...&gt; [L: list]) ...&gt; qc = Qlc.cursor(qlc_handle) ...&gt; Qlc.next_answers(qc, 2) [{:a, 1}, {:b, 2}] ...&gt; Qlc.next_answers(qc, 2) [{:c, 3}, {:d, 4}] ...&gt; Qlc.delete_cursor(qc) :ok","ref":"Qlc.html#next_answers/2","title":"Qlc.next_answers/2","type":"function"},{"doc":"optoin list to record(:qlc_opt)","ref":"Qlc.html#options/3","title":"Qlc.options/3","type":"function"},{"doc":"string to qlc_handle with variable bindings.string may be literal or variable. If string is variable or function call, then expanding to string_to_handle/3 automatically. elixir expression using bang macro are available to interpolation, but expanding to erlang expression string. see examples.syntax[Expression || Qualifier1, Qualifier2, ...] Expression :: arbitary Erlang term (the template) Qualifier :: Filter or Generators Fiilter :: Erlang expressions returning bool() Generator :: Pattern &lt;- ListExpression ListExpression :: Qlc_handle or list() Qlc_handle :: returned from Qlc.table/2, Qlc.sort/2, Qlc.keysort/3 Qlc.q/2, Qlc.string_to_handle/2exampleiex&gt; require Qlc iex&gt; list = [a: 1,b: 2,c: 3] iex&gt; qlc_handle = Qlc.q(&quot;[X || X = {K,V} &lt;- L, K =/= Item]&quot;, ...&gt; [L: list, Item: :b]) ...&gt; Qlc.e(qlc_handle) [a: 1, c: 3] ...&gt; Qlc.q(&quot;[X || X = {K, V} &lt;- L, K =:= Item]&quot;, ...&gt; [L: qlc_handle, Item: :c]) |&gt; ...&gt; Qlc.e [c: 3] ...&gt; query_string = &quot;[X || X = {K, V} &lt;- L, K =:= Item]&quot; ...&gt; bindings = [L: list, Item: :b] ...&gt; Qlc.q(query_string, bindings) |&gt; Qlc.e() [b: 2] iex&gt; ## Qlc.Record.defrecord(:user, [id: nil, name: nil, age: nil]) iex&gt; list = [user(id: 1, name: :foo, age: 10), ...&gt; user(id: 2, name: :bar, age: 20), ...&gt; user(id: 3, name: :baz, age: 30)] ...&gt; query_string = &quot;[X || X &lt;- L, \#{user!(X, :age)} &lt; Age]&quot; ...&gt; bindings = [L: list, Age: 20] ...&gt; Qlc.q(query_string, bindings) |&gt; Qlc.e() [{:user, 1, :foo, 10}]","ref":"Qlc.html#q/3","title":"Qlc.q/3","type":"macro"},{"doc":"","ref":"Qlc.html#qlc_handle/1","title":"Qlc.qlc_handle/1","type":"macro"},{"doc":"","ref":"Qlc.html#qlc_handle/2","title":"Qlc.qlc_handle/2","type":"macro"},{"doc":"","ref":"Qlc.html#qlc_lc/1","title":"Qlc.qlc_lc/1","type":"macro"},{"doc":"","ref":"Qlc.html#qlc_lc/2","title":"Qlc.qlc_lc/2","type":"macro"},{"doc":"","ref":"Qlc.html#qlc_opt/1","title":"Qlc.qlc_opt/1","type":"macro"},{"doc":"","ref":"Qlc.html#qlc_opt/2","title":"Qlc.qlc_opt/2","type":"macro"},{"doc":"Returns a query handle. When evaluating returned query handle, the answers to query handle argument are sorted by the query_handle() options.exampleiex&gt; list = [a: 3, b: 2, c: 1] iex&gt; Qlc.q(&quot;[ X || X &lt;- L]&quot;, [L: list]) |&gt; ...&gt; Qlc.sort(order: :descending) |&gt; ...&gt; Qlc.e() [c: 1, b: 2, a: 3]","ref":"Qlc.html#sort/2","title":"Qlc.sort/2","type":"function"},{"doc":"string to qlc_handle with variable bindings","ref":"Qlc.html#string_to_handle/3","title":"Qlc.string_to_handle/3","type":"function"},{"doc":"create qlc handle for any. see :qlc.table/2exampleiex&gt; q = Qlc.table(fn() -&gt; [a: 1, b: 2, c: 3] end, []) ...&gt; Qlc.q(&quot;[X || X = {K, V} &lt;- L, K =:= Y]&quot;, [L: q, Y: :a]) |&gt; ...&gt; Qlc.e() [a: 1] iex&gt; tf = fn(r, f) -&gt; ...&gt; [r.first | ...&gt; fn() -&gt; ...&gt; last = r.last ...&gt; case r.first do ...&gt; x when x &lt; last -&gt; ...&gt; f.(Range.new(r.first+1, last), f) ...&gt; _x -&gt; [] ...&gt; end ...&gt; end] ...&gt; end ...&gt; trf = fn(r) -&gt; tf.(r, tf) end ...&gt; q = Qlc.table(fn() -&gt; trf.(1..3) end, []) ...&gt; Qlc.q(&quot;[X || X &lt;- Q, X &gt; 2]&quot;, [Q: q]) |&gt; Qlc.e() [3]","ref":"Qlc.html#table/2","title":"Qlc.table/2","type":"function"},{"doc":"","ref":"Qlc.html#t:abstract_expr/0","title":"Qlc.abstract_expr/0","type":"type"},{"doc":"","ref":"Qlc.html#t:binding_struct/0","title":"Qlc.binding_struct/0","type":"type"},{"doc":"","ref":"Qlc.html#t:bindings/0","title":"Qlc.bindings/0","type":"type"},{"doc":"","ref":"Qlc.html#t:error_info/0","title":"Qlc.error_info/0","type":"type"},{"doc":"","ref":"Qlc.html#t:expr/0","title":"Qlc.expr/0","type":"type"},{"doc":"key position for sorting tuples.indexed by 0 (elixir's tuple element indexing).","ref":"Qlc.html#t:key_pos/0","title":"Qlc.key_pos/0","type":"type"},{"doc":"","ref":"Qlc.html#t:object_list/0","title":"Qlc.object_list/0","type":"type"},{"doc":"","ref":"Qlc.html#t:objects/0","title":"Qlc.objects/0","type":"type"},{"doc":"order functiondetect order if smaller =&lt; bigger then return true else false.","ref":"Qlc.html#t:order_fun/0","title":"Qlc.order_fun/0","type":"type"},{"doc":"order optionorder by elixir native ascending, descending or order_fun(). default is ascending.","ref":"Qlc.html#t:order_option/0","title":"Qlc.order_option/0","type":"type"},{"doc":"","ref":"Qlc.html#t:qlc_lc/0","title":"Qlc.qlc_lc/0","type":"type"},{"doc":"","ref":"Qlc.html#t:qlc_opt/0","title":"Qlc.qlc_opt/0","type":"type"},{"doc":"","ref":"Qlc.html#t:qlc_opt_list/0","title":"Qlc.qlc_opt_list/0","type":"type"},{"doc":"","ref":"Qlc.html#t:query_cursor/0","title":"Qlc.query_cursor/0","type":"type"},{"doc":"","ref":"Qlc.html#t:query_handle/0","title":"Qlc.query_handle/0","type":"type"},{"doc":"sorting option.see :qlc.sort/2","ref":"Qlc.html#t:sort_option/0","title":"Qlc.sort_option/0","type":"type"},{"doc":"","ref":"Qlc.html#t:sort_options/0","title":"Qlc.sort_options/0","type":"type"},{"doc":"","ref":"Qlc.html#t:table_options/0","title":"Qlc.table_options/0","type":"type"},{"doc":"","ref":"Qlc.html#t:traverse_fun/0","title":"Qlc.traverse_fun/0","type":"type"},{"doc":"","ref":"Qlc.html#t:traverse_fun0/0","title":"Qlc.traverse_fun0/0","type":"type"},{"doc":"","ref":"Qlc.html#t:traverse_fun1/0","title":"Qlc.traverse_fun1/0","type":"type"},{"doc":"","ref":"Qlc.html#t:traverse_result/0","title":"Qlc.traverse_result/0","type":"type"},{"doc":"unique option for sorting.only the first of a sequence of terms that compare equal(==) is output if this option is set to true. defaults to false.","ref":"Qlc.html#t:unique_option/0","title":"Qlc.unique_option/0","type":"type"},{"doc":"","ref":"Qlc.Cursor.html","title":"Qlc.Cursor","type":"module"},{"doc":"","ref":"Qlc.Cursor.html#t:t/0","title":"Qlc.Cursor.t/0","type":"type"},{"doc":"Record enhancementbang!/2 macro provide erlang expression for record access in QLC expression.exampleiex&gt; user([id: 1, name: :foo, age: 10]) {:user, 1, :foo, 10} iex&gt; List.flatten(user!({:user, 1, :foo, 10}, :name)) &#39; element(3, {user,1,foo,10}) &#39; iex&gt; &quot;\#{user!({:user, 2, :bar, 10}, :age)}&quot; &quot; element(4, {user,2,bar,10}) &quot;","ref":"Qlc.Record.html","title":"Qlc.Record","type":"module"},{"doc":"define fields/1 function for getting record definitionexample","ref":"Qlc.Record.html#defrecord/2","title":"Qlc.Record.defrecord/2","type":"macro"},{"doc":"QlcQlc is implementation erlang's qlc interface by elixir.The qlc module implements a query interface to QLC tables. Typical QLC tables are ETS, Dets, and Mnesia tables. There is also support for user defined tables, see the Implementing a QLC table section. A query is stated using Query List Comprehensions (QLCs). for more information, see erlang reference manual","ref":"readme.html","title":"Qlc","type":"extras"},{"doc":"find sure qlc.erl in 'stdlib/src'.mix testmix docs (option)","ref":"readme.html#build","title":"Qlc - build","type":"extras"},{"doc":"Allow erlang style list comprehensions for List, ets, Dets, Mnesia QLC tables.exampleiex&gt; require Qlc iex&gt; list = [a: 1,b: 2,c: 3] iex&gt; qlc_handle = Qlc.q(&quot;[X || X = {K,V} &lt;- L, K =/= Item]&quot;, ...&gt; [L: list, Item: :b]) ...&gt; Qlc.e(qlc_handle) [a: 1, c: 3]Qlc.Record.defrecord/2 defines the bang!/2 macro expanding to 'element(index, record)', for treating record element in qlc query.Examplesiex(1)&gt; require Qlc.Record Qlc.Record iex(2)&gt; require Qlc Qlc iex(3)&gt; defmodule A do ...(3)&gt; Qlc.Record.defrecord(:item, [id: nil, name: nil, age: nil]) ...(3)&gt; end {:module, A, &lt;&lt;70, 79, 82, 49, 0, 0, 10, 48, 66, 69, ...&gt;&gt;, {:item!, 2}} iex(4)&gt; require A A iex(5)&gt; import A A iex(6)&gt; item() {:item, nil, nil, nil} iex(7)&gt; item([id: 1, name: :foo, age: 10]) {:item, 1, :foo, 10} iex(8)&gt; item!({:item, 1, :foo, 10}, :age) [ 32, 101, 108, 101, 109, 101, 110, 116, 40, &#39;4&#39;, 44, 32, [[123, [&#39;item&#39;, 44, &#39;1&#39;, 44, &#39;foo&#39;, 44, &#39;10&#39;], 125]], 41, 32 ] iex(9)&gt; item!({:item, 1, :foo, 10}, :age)|&gt;List.flatten() &#39; element(4, {item,1,foo,10}) &#39; iex(10)&gt; list = [item(id: 1, name: :a, age: 1), ...(10)&gt; item(id: 2, name: :b, age: 10), ...(10)&gt; item(id: 3, name: :c, age: 20)] [{:item, 1, :a, 1}, {:item, 2, :b, 10}, {:item, 3, :c, 20}] iex(11)&gt; Qlc.q(&quot;[ X || X &lt;- L, (N = \#{item!(X, :name)}) =:= Name]&quot;, ...(11)&gt; [L: list, Name: :b]) |&gt; ...(11)&gt; Qlc.sort(order: :descending) |&gt; ...(11)&gt; Qlc.e() [{:item, 2, :b, 10}] ## Cannot use bang!/2 macro with variable, can use literal only iex(12)&gt; b = item([id: 1, name: :foo, age: 10]) {:item, 1, :foo, 10} iex(13)&gt; item!(b, :name) warning: variable &quot;b&quot; does not exist and is being expanded to &quot;b()&quot;, please use parentheses to remove the ambiguity or change the variable name iex(14)&gt;","ref":"readme.html#feature","title":"Qlc - feature","type":"extras"},{"doc":"MIT licenses.","ref":"readme.html#licenses","title":"Qlc - licenses","type":"extras"}]